#include "log_h"
#include "utility_h"
#include "wrappers_h"
#include "events_h"
#include "plt_pre100pt_ritual"
#include "plt_denpt_main"

void main()
{
    event ev = GetCurrentEvent();
    int nEventType = GetEventType(ev);
    string sDebug;
    object oPC = GetHero();
    object oParty = GetParty(oPC);
    int nEventHandled = FALSE;

// //////////////////////
// Give Grey Warden Skill
// ////////////////////// 

    object oJustice     = GetObjectByTag("gxa000fl_justice");
    object oAlistair    = GetObjectByTag("gen00fl_alistair");
    object oLoghain     = GetObjectByTag("gen00fl_loghain");

//  ID from ABI_gxa m2da
    int nGWarden    = 401006;
    
//  This might have been set already in includes but imma set it again
    int nLvl = GetLevel(oPC);

//    Not sure if broken with Awakening in the OC or just broken period
//    int nAwakening  = IsUsingEP1Resources();

    switch (nEventType)
    {   
//        These didn't appear to fire for some reason
//        case EVENT_TYPE_MODULE_LOAD:
//        case EVENT_TYPE_MODULE_ENTER:
//        {
//        }
//      Script will only fire on party change
        case EVENT_TYPE_PARTYMEMBER_ADDED:
        case EVENT_TYPE_PARTY_MEMBER_HIRED:
        {
//              Alistair and Justice are always wardens by the time you meet them, should always have flag
                if (IsObjectValid(oAlistair) == TRUE && HasAbility(oAlistair, nGWarden) == FALSE)
                {
                    AddAbility(oAlistair, nGWarden, FALSE); // display on-screen notification = false
                }
                if (IsObjectValid(oJustice) == TRUE && HasAbility(oJustice, nGWarden) == FALSE)
                {
                    AddAbility(oJustice, nGWarden, FALSE);
                }
//              Let's add a plot check for after the Landsmeet just to make sure Loghain isn't buffed during his duel  
                if (IsObjectValid(oLoghain) == TRUE && HasAbility(oLoghain,nGWarden) == FALSE && WR_GetPlotFlag(PLT_DENPT_MAIN, LANDSMEET_DUEL_CUTSCENE_END) == TRUE)
                {
                    AddAbility(oLoghain, nGWarden, FALSE);
                }
//              Make sure the skill isn't granted before the plot flag from the PC's joining is set
                if (HasAbility(oPC, nGWarden) == FALSE && WR_GetPlotFlag(PLT_PRE100PT_RITUAL, PRE_RITUAL_END) == TRUE)
                {
                    AddAbility(oPC, nGWarden, FALSE);
                }
//              Orlesian warden won't have flag from joining, so restrict to level 18 to catch new PC without applying to level ones
                if (HasAbility(oPC, nGWarden) == FALSE && nLvl >= 18)
                {
                    AddAbility(oPC, nGWarden, FALSE);
                }
            break;
        }
    }
//    Unnecessary since only listening event with event manager, not overriding
//    if (!nEventHandled)
//    {
//        HandleEvent(ev, RESOURCE_SCRIPT_MODULE_CORE);
//    }
}